
function [Jc,dJ,H] = NPIRobjFctn(Ts,R,omega,m,yRef,yc,alpha,beta,P,hd,Dx,Dy)

doDerivative = (nargout>=2);           

% compute interpolated image and derivative, formally: center(yc) = P*yc
[T,dT] = splineInterMex(Ts,omega,center(yc,m),'doDerivative',doDerivative);

% distance measure：SSD
rc = T - R;              		
Dc = 0.5*hd*(rc'*rc);       
					
% regularizer
[Sc,dS,d2S] = regularizer(yc-yRef,omega,m,hd,alpha,beta,Dx,Dy,'doDerivative',doDerivative);

% evaluate joint function and return if no derivatives need to be computed
Jc = Dc + Sc;

if ~doDerivative
    return; 
end


dr  = dT*P;
drT = dr';
dD  = hd * drT*rc;

dJ  = dD + dS;
H  = hd*(drT*dr) + d2S;
  
end


