%% Generate multilevel data

function MLdata = getMultileveldata(dataT,dataR,m,omega,MinLevel,MaxLevel)
    
xc = getCellCenteredGrid(omega,m);
T = linearInter(dataT,omega,xc);
T = reshape(T,m);
R = linearInter(dataR,omega,xc);
R = reshape(R,m);

Singledata.T = T;
Singledata.R = R;
Singledata.m = m;

MLdata{MaxLevel} = Singledata;

for Level = MaxLevel-1:-1:MinLevel
   
    m = m/2;
    T = MLdata{Level+1}.T;
    T = (T(1:2:end-1,1:2:end-1)+T(1:2:end-1,2:2:end)+T(2:2:end,1:2:end-1)+T(2:2:end,2:2:end))/4;
    R = MLdata{Level+1}.R;
    R = (R(1:2:end-1,1:2:end-1)+R(1:2:end-1,2:2:end)+R(2:2:end,1:2:end-1)+R(2:2:end,2:2:end))/4;

    Singledata.T = T;
    Singledata.R = R;
    Singledata.m = m;

    MLdata{Level} = Singledata;
end
