function Yt = lineSearch(objFctn,Yc,dY,Jc,dJ,Dx,Dy)

LSMaxIter   = 10;          
LSreduction = 1e-4;         
descent     = dJ' * dY; 

t = 1; LS = 0;
for LSiter =1:LSMaxIter
  Yt = Yc + t*dY; 	

  Y  = reshape(Yt,[],2);
  Y1 = Y(:,1);
  Y2 = Y(:,2);
  Range = (Dx*Y1).*(Dy*Y2)-(Dx*Y2).*(Dy*Y1);
  DIFFEOMORPHIC = (min(Range)>0);    
  if DIFFEOMORPHIC
    Jt = objFctn(Yt);              
    LS = (Jt<Jc + t*LSreduction*descent); 
    if LS 
        break; 
    end            
  end
  t = t/2;                         
end

if LS
    return; 
end                

if not(DIFFEOMORPHIC) 
    fprintf(['Line Search failed (No diffeomorphic update could be found)'...
        '- norm(dY)=%1.3e - break \n'],norm(dY));
elseif not(LS)
    fprintf(['Line Search failed (No sufficient descent found) '...
        '- norm(dY)=%1.3e - break\n'],norm(dY));
end

Yt = Yc;        

