
function plotresult(MLdata,n,yc,yRef,omega,m,Dx,Dy)

T = MLdata{n}.T;
R = MLdata{n}.R;

T = linearInter(T,omega,center(yRef,m));
T = reshape(T,m);

R = linearInter(R,omega,center(yRef,m));
R = reshape(R,m);

Tc = linearInter(T,omega,center(yc,m));
Tc = reshape(Tc,m);

E1 = 0.5/prod(m)*(Tc(:)-R(:))'*(Tc(:)-R(:));
E2 = 0.5/prod(m)*(T(:)-R(:))'*(T(:)-R(:));
Re_SSD = E1/E2

Y  = reshape(yc,[],2);
Y1 = Y(:,1);
Y2 = Y(:,2);
JacdetRange = (Dx*Y1).*(Dy*Y2)-(Dx*Y2).*(Dy*Y1);
JacdetRange = sum(reshape(JacdetRange,[],4),2)/4;
MaxJacdet = max(JacdetRange)
MinJacdet = min(JacdetRange)


figure(1)
subplot(2,2,1)
imshow(flipud(T'),[])
title('Template')

subplot(2,2,2)
imshow(flipud(R'),[])
title('Reference')

subplot(2,2,3)
Y1 = reshape(Y1,m+1);
Y1 = imresize(Y1,[64,64],'bilinear');
Y2 = reshape(Y2,m+1);
Y2 = imresize(Y2,[64,64],'bilinear');
mesh(Y1,Y2,zeros(64));

view([0 90]);
axis image
title('Transformation')

subplot(2,2,4)
imshow(flipud(Tc'),[])
title('Deformed Template')
